import greenfoot.GreenfootImage;
import java.awt.image.BufferedImage;
import java.awt.Color;

/**
 * DynamicWall
 * 
 * @author Taylor Born
 * @version October 2013
 */
public class DynamicWall extends Wall
{
//     protected Integer[][] colors;
    
    protected int[][][][] colors2;
    
    protected boolean[] windows = new boolean[SIZE];

    public DynamicWall(GreenfootImage pic)
    {
        super(pic);
//         colors = new Integer[SIZE][SIZE];
        colors2 = new int[SIZE][SIZE][100][4];
        for (int c = 0; c < SIZE; c++)
        {
            Color lastColor = pic.getColorAt(c, 0);
//             colors[c][0] = lastColor.getAlpha() == 255 ? lastColor.getRGB() : null;
            
            colors2[c][0][99] = lastColor.getAlpha() == 255 ? new int[]{ lastColor.getRed(), lastColor.getGreen(), lastColor.getBlue(), 255 } : new int[]{ -1, -1, -1, -1 };
            if (lastColor.getAlpha() == 255)
            for (int i = 0; i < 99; i++)
                colors2[c][0][i] = new int[]{ (int)(colors2[c][0][99][0] * (i / 100d)), (int)(colors2[c][0][99][1] * (i / 100d)), (int)(colors2[c][0][99][2] * (i / 100d)), 255 };
            
            for (int r = 1; r < SIZE; r++)
            {
                Color color = pic.getColorAt(c, r);
                if (lastColor.equals(color))
                {
//                     colors[c][r] = colors[c][r - 1];
                    colors2[c][r] = colors2[c][r - 1];
                }
                else
                {
//                     colors[c][r] = color.getAlpha() == 255 ? color.getRGB() : null;
                    colors2[c][r][99] = color.getAlpha() == 255 ? new int[]{ color.getRed(), color.getGreen(), color.getBlue(), 255 } : new int[]{ -1, -1, -1, -1 };
                    
                    if (color.getAlpha() == 255)
                        for (int i = 0; i < 99; i++)
                            colors2[c][r][i] = new int[]{ (int)(colors2[c][r][99][0] * (i / 100d)), (int)(colors2[c][r][99][1] * (i / 100d)), (int)(colors2[c][r][99][2] * (i / 100d)), 255 };
                    
                    lastColor = color;
                }
                
                if (lastColor.getAlpha() != 255)
                    windows[c] = true;
            }
        }
    }
    public boolean isWindow(int column)
    {
        return windows[column];
    }
    public int[][] getColor(int c, int r)
    {
        return colors2[c][r];
    }
    public void draw(FastImage fastImage, int columnInImage, int c, int y, int height, int fade)
    {
        int x = c % (Screen.WIDTH / 2);
        
        double r = 0;
        if (Screen.HEIGHT / 2 - height < 0)
            r = -(Screen.HEIGHT / 2 - height);
        for (; r < height * 2; r++)
        {
            double rr = Screen.HEIGHT / 2 - height + r;
            if (rr >= Screen.HEIGHT)
                break;
            
            int rowInImage = (int)(r / (double)(height * 2) * Wall.SIZE);
            if (colors2[columnInImage][rowInImage][99][0] != -1)// != null)
                fastImage.setPixel(x, (int)rr, colors2[columnInImage][rowInImage][fade]);
//                 bufferedImage.setRGB(x, (int)rr, colors[columnInImage][rowInImage]);
        }
    }
}