import greenfoot.Actor;
import greenfoot.GreenfootImage;
import greenfoot.UserInfo;
import java.awt.image.BufferedImage;
import java.awt.Color;

/**
 * LoadProgress
 * 
 * @author Taylor Born
 * @version September 2013
 */
public class LoadProgress extends Actor
{
    private final int WIDTH = 200;
    private final int HEIGHT = 30;
    private GreenfootImage pic = new GreenfootImage(WIDTH, HEIGHT);
//     private int progress;
    private final int COUNT = 3 + 2; // Number of SliceWalls that will be created
    private volatile boolean done = false;

    public LoadProgress()
    {
        setImage(pic);
        
        (new Thread(new Loader())).start();
    }
    public void act()
    {
        pic.clear();
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLUE);
        pic.fillRect(0, 0, getProgress(), HEIGHT);
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, WIDTH - 1, HEIGHT - 1);
        if (done)
            getWorld().removeObject(this);
    }
    private int getProgress()
    {
        return 0;//(int)(SliceWall.getProgress(COUNT) * WIDTH);
    }
    private class Loader implements Runnable
    {
        public void run()
        {
            Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
//             Tile.clear();
            Map.clear();
            WallIntersect.clear();
            MovingObject.wall = null;
            
//             SliceWall.progress = 0;
            
            GreenfootImage tree = new GreenfootImage("Tree.png");
            FixtureWall treeMid = new FixtureWall(tree);//, Slice.MAX_TREE_SCALE);
//             progress++;
            GreenfootImage treeL = new GreenfootImage(tree.getWidth(), tree.getHeight());
            treeL.drawImage(tree, -tree.getWidth() / 2, 0);
            FixtureWall treeLeft = new FixtureWall(treeL);//, Slice.MAX_TREE_SCALE);
//             progress++;
            GreenfootImage treeR = new GreenfootImage(tree.getWidth(), tree.getHeight());
            treeR.drawImage(tree, tree.getWidth() / 2, 0);
            FixtureWall treeRight = new FixtureWall(treeR);//, Slice.MAX_TREE_SCALE);
//             progress++;
            GreenfootImage treeB = new GreenfootImage(tree.getWidth(), tree.getHeight());
            treeB.drawImage(treeL, 0, 0);
            treeB.drawImage(treeR, 0, 0);
            FixtureWall treeBoth = new FixtureWall(treeB);//, Slice.MAX_TREE_SCALE);
//             progress++;
            Map.setTreeWalls(treeMid, treeLeft, treeRight, treeBoth);
            
            
            //SliceWall
            Wall w1 = new DynamicWall(new GreenfootImage("Wall.png"));
            
            
            ElevatorWall.wallpaper1 = null;
            ElevatorWall.wallpaper1 = new DynamicWall(new GreenfootImage("elevWallpaper1.png"));//already was dynamic
            ElevatorWall.wallpaper2 = null;
            ElevatorWall.wallpaper2 = new DynamicWall(new GreenfootImage("elevWallpaper2.png"));
            
            //progress++;
            Wall w2 = new DynamicWall(new GreenfootImage("Window.png"));
            
            Wall w3 = new DynamicWall(new GreenfootImage("Wall2.png"));
            
            Wall w4 = new DynamicWall(new GreenfootImage("Window2.png"));
            
            new Map(new Wall[]{ w1, w2, w3, w4 }); //, new ElevatorWall(6, 9, 1, 0)
            //progress++;
            
            
            GreenfootImage objectIcon;
            if (UserInfo.isStorageAvailable())
            {
                objectIcon = new GreenfootImage(Wall.SIZE, Wall.SIZE);
                GreenfootImage icon = UserInfo.getMyInfo().getUserImage();
                prepareIcon(icon);
                objectIcon.drawImage(icon, objectIcon.getWidth() / 2 - icon.getWidth() / 2, objectIcon.getHeight() / 2 - icon.getHeight() / 2);
            }
            else
                objectIcon = new GreenfootImage("Bourne.png");
            MovingObject.wall = new FixtureWall(objectIcon);//, 400);
//             progress++;
            
            GreenfootImage sky = new GreenfootImage("stars.jpg");
//             BufferedImage[][] skies = new BufferedImage[sky.getWidth()][sky.getWidth()];
            int[][][][] skies = new int[sky.getWidth()][sky.getWidth()][sky.getHeight()][4];
            for (int i = 0; i < skies.length; i++)
            {
                GreenfootImage s = new GreenfootImage(1, sky.getHeight());
                s.drawImage(sky, -i, 0);
                
//                 skies[i][sky.getWidth() - 1] = s.getAwtImage();
                for (int k = 0; k < sky.getWidth(); k++)//- 1
                {
                    GreenfootImage p = new GreenfootImage(s);
                    p.scale(1, k + 1);
                    
                    for (int j = 0; j < k + 1; j++)
                    {
                        Color color = p.getColorAt(0, j);
                        skies[i][k][j] = new int[]{ color.getRed(), color.getGreen(), color.getBlue(), 255 };
                    }
                    
//                     skies[i][k] = p.getAwtImage();
                }
            }
//             GreenfootImage g = new GreenfootImage(1, Screen.HEIGHT / 2);
//             for (int i = 0; i < g.getHeight(); i++)
//                 g.setColorAt(0, i, new Color(0, (int)(i / (double)g.getHeight() * 120), 0));
            
            int[][] foci = { { -20, 0 }, { Screen.WIDTH + 20, 0 } };
            
            final int[] POINT = { Screen.WIDTH / 2, Screen.HEIGHT / 2 };
            double maxDis = Math.sqrt(Math.pow(POINT[0] - foci[0][0], 2) + Math.pow(POINT[1] - foci[0][1], 2)) +
                            Math.sqrt(Math.pow(POINT[0] - foci[1][0], 2) + Math.pow(POINT[1] - foci[1][1], 2));
            
            int[][][] ceil = new int[Screen.WIDTH][Screen.HEIGHT / 2][4];
            for (int i = 0; i < ceil.length; i++)
                for (int k = 0; k < ceil[0].length; k++)
                {
                    double dis = Math.sqrt(Math.pow(i - foci[0][0], 2) + Math.pow(k - foci[0][1], 2)) +
                                 Math.sqrt(Math.pow(i - foci[1][0], 2) + Math.pow(k - foci[1][1], 2));
                    
                    double n = Math.max(1 - dis / maxDis, 0);
                    ceil[i][k] = new int[]{ (int)(n * 196), (int)(n * 208), (int)(n * 255), 255 };
                }
            
            foci = new int[][]{ { -20, Screen.HEIGHT / 2 }, { Screen.WIDTH + 20, Screen.HEIGHT / 2 } };
            
            int[][][] floor = new int[Screen.WIDTH][Screen.HEIGHT / 2][4];
            for (int i = 0; i < floor.length; i++)
                for (int k = 0; k < floor[0].length; k++)
                {
                    double dis = Math.sqrt(Math.pow(i - foci[0][0], 2) + Math.pow(k - foci[0][1], 2)) +
                                 Math.sqrt(Math.pow(i - foci[1][0], 2) + Math.pow(k - foci[1][1], 2));
                    
                    double n = Math.max(1 - dis / maxDis, 0);//i / (double)floor.length);
                    floor[i][k] = new int[]{ (int)(n * 229), (int)(n * 255), (int)(n * 191), 255 };
                }
            
//             int[][] grass = new int[Screen.HEIGHT / 2][4];
//             for (int i = 0; i < grass.length; i++)
//             {
//                 grass[i] = new int[]{ 0, (int)(i / (double)grass.length * 120), 0, 255 };
//             }
            
            int[][][] grass = new int[Screen.WIDTH][Screen.HEIGHT / 2][4];
            for (int i = 0; i < grass.length; i++)
                for (int k = 0; k < grass[0].length; k++)
                {
                    double dis = Math.sqrt(Math.pow(i - foci[0][0], 2) + Math.pow(k - foci[0][1], 2)) +
                                 Math.sqrt(Math.pow(i - foci[1][0], 2) + Math.pow(k - foci[1][1], 2));
                    
                    grass[i][k] = new int[]{ 0, (int)(Math.max(1 - dis / maxDis, 0) * 255), 0, 255 };
                }
            
            
//             grass = g.getAwtImage();
            
            WallIntersect.set(skies, ceil, floor, grass);
            //progress++;
            done = true;
        }
    }
    private void prepareIcon(GreenfootImage p)
    {
        for (int r = 0; r < p.getHeight(); r++)
            for (int c = 0; c < p.getWidth(); c++)
            {
                double dist = Math.sqrt(Math.pow(c - (p.getWidth() / 2), 2) + Math.pow(r - (p.getHeight() / 2), 2));
                if (dist >= p.getWidth() / 2)
                    p.setColorAt(c, r, new Color(0, 0, 0, 0));
//                 else if (dist >= p.getWidth() / 2 - 3)
//                 {
//                     Color col = p.getColorAt(c, r);
//                     p.setColorAt(c, r, new Color(col.getRed(), col.getGreen(), col.getBlue(), (int)((1 - (dist - (p.getWidth() / 2 - 3)) / 3d) * 255)));
//                 }
            }
//             try
//             {
//                 javax.imageio.ImageIO.write(p.getAwtImage(), "png", new java.io.File("images/" + "Test" + ".png"));
//             }
//             catch (java.io.IOException ex)
//             {}
    }
}