/**
 * MovingObject
 * 
 * @author Taylor Born
 * @version September 2013
 */
public class MovingObject extends PathFinder
{
    private double x, y;
    private double distanceFromPlyr;
    
    private double leftX, leftY, rightX, rightY;
    
    public static Wall wall;

    public MovingObject(int c, int r)
    {
        super(c, r);
        x = c * Tile.SIZE + Tile.SIZE / 2;
        y = r * Tile.SIZE + Tile.SIZE / 2;
    }
    protected int getGridX()
    {
        return (int)x / Tile.SIZE;
    }
    protected int getGridY()
    {
        return (int)y / Tile.SIZE;
    }
    public double getX()
    {
        return x;
    }
    public double getY()
    {
        return y;
    }
    protected boolean moveTowardGridLocAndReturnIsNear(int x, int y)
    {
        int xd = x * Tile.SIZE + Tile.SIZE / 2;
        int yd = y * Tile.SIZE + Tile.SIZE / 2;
        
        if (this.x < xd)
            this.x += 5;
        else if (this.x > xd)
            this.x -= 5;
        if (this.y < yd)
            this.y += 5;
        else if (this.y > yd)
            this.y -= 5;
        
        return Math.sqrt(Math.pow(xd - this.x, 2) + Math.pow(yd - this.y, 2)) == 0;
    }
    public double distanceFromPlayer()
    {
        return distanceFromPlyr;
    }
    public void calculateDistanceFromPlayer(double px, double py)
    {
        distanceFromPlyr = Math.sqrt(Math.pow(px - x, 2) + Math.pow(py - y, 2));
        double dirToPlyr = Math.atan2(y - py, x - px);
        leftX = x + Math.cos(dirToPlyr + Math.PI / 2) * Tile.SIZE / 2;
        leftY = y + Math.sin(dirToPlyr + Math.PI / 2) * Tile.SIZE / 2;
        rightX = x + Math.cos(dirToPlyr - Math.PI / 2) * Tile.SIZE / 2;
        rightY = y + Math.sin(dirToPlyr - Math.PI / 2) * Tile.SIZE / 2;
    }
    public double distanceFromLeft(double x, double y)
    {
        return Math.sqrt(Math.pow(x - leftX, 2) + Math.pow(y - leftY, 2));
    }
    public double distanceFromRight(double x, double y)
    {
        return Math.sqrt(Math.pow(x - rightX, 2) + Math.pow(y - rightY, 2));
    }
    public Wall getWall()
    {
        return wall;
    }
}