import greenfoot.Greenfoot;

/**
 * Player
 * 
 * @author Taylor Born
 * @version October 2013
 */
public class Player 
{
    public static Player main;

    private double x = 8 * Tile.SIZE;
    private double y = 9 * Tile.SIZE;
    private int rotation = 90;

    public Player()
    {
        main = this;
    }
    
    /**
     * Handle controls.
     */
    public void act()
    {
        if (Greenfoot.isKeyDown("a"))
            rotation -= 5;
        else if (Greenfoot.isKeyDown("d"))
            rotation += 5;
        
        if (Greenfoot.isKeyDown("w"))
            move(rotation);
        if (Greenfoot.isKeyDown("s"))
            move(rotation + 180);
        
        if (Greenfoot.isKeyDown("q"))
            move(rotation - 90);
        if (Greenfoot.isKeyDown("e"))
            move(rotation + 90);
    }
    private void move(int r)
    {
        double newX = x + Math.cos(Math.toRadians(r)) * 3;
        if (!movedWithinWalls(newX, y))
            x = newX;
        double newY = y + Math.sin(Math.toRadians(r)) * 3;
        if (!movedWithinWalls(x, newY))
            y = newY;
    }
    private boolean movedWithinWalls(double x, double y)
    {
        Map map = Map.main;
        if (x % Tile.SIZE < Tile.SIZE * .1)
        {
            if (map.getTiles()[(int)(y / Tile.SIZE)][(int)(x / Tile.SIZE)].hasWestBarrier())
                return true;
            else if (y % Tile.SIZE < Tile.SIZE * .1)
            {
                if (map.getTiles()[(int)(y / Tile.SIZE)][(int)(x / Tile.SIZE - 1)].hasNorthBarrier())
                    return true;
            }
            else if (y % Tile.SIZE > Tile.SIZE * .9)
                if (map.getTiles()[(int)(y / Tile.SIZE) + 1][(int)(x / Tile.SIZE) - 1].hasNorthBarrier())
                    return true;
        }
        else if (x % Tile.SIZE > Tile.SIZE * .9)
            if (map.getTiles()[(int)(y / Tile.SIZE)][(int)(x / Tile.SIZE) + 1].hasWestBarrier())
                return true;
            else if (y % Tile.SIZE < Tile.SIZE * .1)
            {
                if (map.getTiles()[(int)(y / Tile.SIZE)][(int)(x / Tile.SIZE) + 1].hasNorthBarrier())
                    return true;
            }
            else if (y % Tile.SIZE > Tile.SIZE * .9)
                if (map.getTiles()[(int)(y / Tile.SIZE) + 1][(int)(x / Tile.SIZE) + 1].hasNorthBarrier())
                    return true;
        if (y % Tile.SIZE < Tile.SIZE * .1)
        {
            if (map.getTiles()[(int)(y / Tile.SIZE)][(int)(x / Tile.SIZE)].hasNorthBarrier())
                return true;
            else if (x % Tile.SIZE < Tile.SIZE * .1)
            {
                if (map.getTiles()[(int)(y / Tile.SIZE) - 1][(int)(x / Tile.SIZE)].hasWestBarrier())
                    return true;
            }
            else if (x % Tile.SIZE > Tile.SIZE * .9)
                if (map.getTiles()[(int)(y / Tile.SIZE) - 1][(int)(x / Tile.SIZE) + 1].hasWestBarrier())
                    return true;
        }
        else if (y % Tile.SIZE > Tile.SIZE * .9)
            if (map.getTiles()[(int)(y / Tile.SIZE) + 1][(int)(x / Tile.SIZE)].hasNorthBarrier())
                return true;
            else if (x % Tile.SIZE < Tile.SIZE * .1)
            {
                if (map.getTiles()[(int)(y / Tile.SIZE) + 1][(int)(x / Tile.SIZE)].hasWestBarrier())
                    return true;
            }
            else if (x % Tile.SIZE > Tile.SIZE * .9)
                if (map.getTiles()[(int)(y / Tile.SIZE) + 1][(int)(x / Tile.SIZE) + 1].hasWestBarrier())
                    return true;
        return false;
    }
    
    public double getDistanceFrom(double x, double y)
    {
        return Math.sqrt(Math.pow(x - ((int)this.x + 0.5), 2) + Math.pow(y - ((int)this.y + 0.5), 2));
    }
    public double getX()
    {
        return x;
    }
    public double getY()
    {
        return y;
    }
    public int getRotation()
    {
        return rotation;
    }
    
    public void positionView(double x, double y, int r)
    {
        this.x = x;
        this.y = y;
        rotation = r;
    }
}