import greenfoot.Greenfoot;
import greenfoot.MouseInfo;
import greenfoot.World;
import java.awt.Point;
import java.util.ArrayList;

/**
 * Screen
 * 
 * @author Taylor Born
 * @version July 2012 - October 2013
 */
public class Screen extends World
{
    public static final int WIDTH = 450;
    public static final int HEIGHT = 350;
    public static Screen main;

    private ArrayList<MovingObject> objects = new ArrayList<MovingObject>();
    private LoadProgress loader = new LoadProgress();
    private Point lastMouse = new Point(0, 0);
    private DrawUtil drawUtil;

    public Screen()
    {
        super(WIDTH, HEIGHT, 1);
        main = this;
        CodeKeyUser.enter();
        addObject(loader, WIDTH / 2, HEIGHT / 2);
        Greenfoot.start();
    }
    
    public void act()
    {
        if (loader != null)
            if (loader.getWorld() == null)
            {
                loader = null;
                objects.add(new MovingObject(3, 3));
                new Player();
                drawUtil = new DrawUtil();
                addObject(new MiniMap(), -50, -50);
            }
            else
                return;
        
        while (drawUtil.isDrawing())
        {}

        KeysPressed.update();
        if (KeysPressed.check("escape"))
            Editor.main.setAsWorld();
        if (KeysPressed.check("n"))
            Raycaster.toggleShowingMovingObjects();
        
        Map.main.operateElevators();
        
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null))
            lastMouse = new Point(mouse.getX(), mouse.getY());
        
        Player.main.act();
        
        for (MovingObject o : objects)
        {
            o.act();
            o.calculateDistanceFromPlayer((int)Player.main.getX() + 0.5, (int)Player.main.getY() + 0.5);
        }
        drawUtil.update();
        
        try
        {
            Thread.currentThread().sleep(20);
        }
        catch (Exception e)
        {}
    }
    public void setAsWorld()
    {
        Greenfoot.setWorld(this);
    }
    public ArrayList<MovingObject> getMovingObjects()
    {
        return objects;
    }
    public Point getLastMouse()
    {
        return lastMouse;
    }
    
//     public void started()
//     {
//         SoundUtil.play();
//     }
//     public void stopped()
//     {
//         SoundUtil.pause();
//     }
}