import greenfoot.GreenfootImage;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.awt.Graphics2D;

/**
 * Slice
 * 
 * @author Taylor Born
 * @version September 2013
 */
public class Slice 
{
    public static final int MAX_WALL_SCALE = 2284; // Tested for maximum need at 2284
    
    private static ArrayList<Slice> slices = new ArrayList<Slice>();
    public static int submitSlice(GreenfootImage slice, int max)
    {
        for (int i = 0; i < slices.size(); i++)
            if (slices.get(i).isSameAs(slice))
                return i;
        slices.add(new Slice(slice, max));
        return slices.size() - 1;
    }
    public static Slice getSlice(int i)
    {
        return slices.get(i);
    }
    private static final int SAMETEST = 12;
//     private static int numSaved = 0;

    private GreenfootImage slice;
    private BufferedImage[] scales;
    private boolean window;

    public Slice(GreenfootImage slice, int max)
    {
        scales = new BufferedImage[max];
        this.slice = slice;
        for (int r = 1; r < slice.getHeight(); r++)
            if (slice.getColorAt(0, r).getAlpha() != 255)
            {
                window = true;
                break;
            }
        
        for (int i = 0; i < scales.length; i++)
        {
            GreenfootImage scaled = new GreenfootImage(slice);
            scaled.scale(1, i + 1);
            
            if (i + 1 > Screen.HEIGHT)
            {
                GreenfootImage s = new GreenfootImage(1, Screen.HEIGHT);
                s.drawImage(scaled, 0, -(scaled.getHeight() - Screen.HEIGHT) / 2);
                scaled = s;
                
                if (i > Screen.HEIGHT - 1 + SAMETEST && max == MAX_WALL_SCALE)
                {
                    boolean flag = false;
                    outR: for (int r = 0; r < Screen.HEIGHT; r++)
                        for (int k = 1; k <= SAMETEST; k++)
                            if (scales[i - k].getRGB(0, r) != scaled.getColorAt(0, r).getRGB())// || scales[i - 2].getRGB(0, r) != scaled.getColorAt(0, r).getRGB())
                            {
                                flag = true;
                                break outR;
                            }
                    if (!flag)
                    {
                        for (int k = i - SAMETEST + 1; k < scales.length; k++)
                        {
                            scales[k] = scales[i - SAMETEST];
//                             numSaved++;
                        }
                        break;
                    }
                }
                
                
//                 boolean flag = false;
//                 outer: for (int k = 399; k < i; k++)
//                 {
//                     flag = false;
//                     for (int c = 0; c < 400; c++)
//                         if (scales[k].getRGB(0, c) != scaled.getColorAt(0, c).getRGB())
//                         {
//                             flag = true;
//                             break;
//                         }
//                     if (!flag)
//                     {
//                         numSaved++; //
//                         scales[i] = scales[k];
//                         flag = true;
//                         break;
//                     }
//                     else
//                         flag = false;
//                 }
//                 if (!flag)
//                     scales[i] = scaled.getAwtImage();
            }
            scales[i] = scaled.getAwtImage();
        }
    }
    public boolean isSameAs(GreenfootImage s)
    {
        for (int r = 0; r < slice.getHeight(); r++)
            if (!slice.getColorAt(0, r).equals(s.getColorAt(0, r)))
                return false;
        return true;
    }
    public boolean isWindow()
    {
        return window;
    }
    public void draw(Graphics2D graphics, int x, int y, int height)
    {
        if (height > 0)
            if (height <= scales.length)
            graphics.drawImage(scales[height - 1], x, (y < 0 ? 0 : y), null);
    }
}