/**
 * Tile
 * 
 * @author Taylor Born
 * @version September - October 2013
 */
public class Tile 
{
    public static final int SIZE = 60;

    private Wall[] northWall = new Wall[2];
    private Wall[] westWall = new Wall[2];

//     public Tile(Wall n, Wall w) //
//     {
//         this(n, n, w, w);
//     }
//     public Tile(Wall n0, Wall n1, Wall w0, Wall w1)
//     {
//         northWall[0] = n0;
//         northWall[1] = n1;
//         westWall[0] = w0;
//         westWall[1] = w1;
//     }
    public Tile(Wall[] walls)
    {
        northWall[0] = walls[0];
        northWall[1] = walls[1];
        westWall[0] = walls[2];
        westWall[1] = walls[3];
    }
    
    public boolean[] hasNorthWallAndIsWindow()
    {
        boolean[] bools = new boolean[2];
        bools[0] = northWall[0] != null || northWall[1] != null;
        if (bools[0])
            bools[1] = (northWall[0] != null && northWall[0].isWindow() || northWall[1] != null && northWall[1].isWindow());
        return bools;
    }
    public boolean[] hasWestWallAndIsWindow()
    {
        boolean[] bools = new boolean[2];
        bools[0] = westWall[0] != null || westWall[1] != null;
        if (bools[0])
            bools[1] = (westWall[0] != null && westWall[0].isWindow() || westWall[1] != null && westWall[1].isWindow());
        return bools;
    }
    
    public Wall getNorthWall(boolean negativeY)
    {
        return northWall[negativeY ? 1 : 0];
    }
    public Wall getWestWall(boolean negativeX)
    {
        return westWall[negativeX ? 1 : 0];
    }
    public void setNorthWall(Wall wall, int i)
    {
        northWall[i] = wall;
    }
    public void setNorthWall(Wall wall, int i, boolean onlyIfNull)
    {
        if (!onlyIfNull || northWall[i] == null)
            northWall[i] = wall;
    }
    public void setNorthWall(Wall wall, boolean nw, boolean se)
    {
        if (nw)
            northWall[0] = wall;
        if (se)
            northWall[1] = wall;
    }
    public void setWestWall(Wall wall, int i)
    {
        westWall[i] = wall;
    }
    public void setWestWall(Wall wall, int i, boolean onlyIfNull)
    {
        if (!onlyIfNull || westWall[i] == null)
            westWall[i] = wall;
    }
    public void setWestWall(Wall wall, boolean nw, boolean se)
    {
        if (nw)
            westWall[0] = wall;
        if (se)
            westWall[1] = wall;
    }
    public boolean hasNorthBarrier()
    {
        if (northWall[0] instanceof ElevatorWall)
            return northWall[0].isBarrier();
        if (northWall[1] instanceof ElevatorWall)
            return northWall[1].isBarrier();
        
        return northWall[0] != null && northWall[0].isBarrier();
    }
    public boolean hasWestBarrier()
    {
        if (westWall[0] instanceof ElevatorWall)
            return westWall[0].isBarrier();
        if (westWall[1] instanceof ElevatorWall)
            return westWall[1].isBarrier();
        return westWall[0] != null && westWall[0].isBarrier();
    }
    public String save()
    {
        return saveWall(northWall[0]) + saveWall(northWall[1]) + saveWall(westWall[0]) + saveWall(westWall[1]);
    }
    private String saveWall(Wall w)
    {
        if (w == null || w instanceof ElevatorWall || w == ElevatorWall.wallpaper2)
            return "0";
        return w.save();
    }
}